LoROM

;ASM to set footstep FX in a room via room index number. 
;This uses no free space, and clears 473 ($1D9) bytes in bank $90 (starting at $90EE0E), and 119 ($77) bytes in bank $91 (starting at $91F15C).
;Room index number is read by bits, max of +03.
;	+00 (------00) = No footstep FX
;	+01 (------01) = Water splash FX
;	+02 (------10) = Dust particle FX
;	+03 (------11) = Smoke puff FX
;Written by Scyzer

org $90ED88 : LDA $0A6E : CMP #$0001 : BNE + : JMP StepSmokeFX
		+ 	  LDA $079D : AND #$0003 : ASL A : TAX : JSR (StepFXTable,X) : RTS
	StepFXTable: DW StepNoFX,StepWaterFX,StepDustFX,StepSmokeFX
	StepNoFX: STZ $0AF0 : STZ $0AF2 : RTS
	StepWaterFX: JSL CheckLiquid : BCC + : RTS 
	+	LDX #$0C08 : LDA $0A1E : BIT #$0004 : BEQ + : LDX #$080C
		+	LDY #$0004 : LDA #$0100 : JSL SetStepFallFX : RTS
	StepDustFX: JSL CheckLiquid : BCC + : RTS
	+	LDX #$0C08 : LDA $0A1E : BIT #$0004 : BEQ + : LDX #$080C
		+	LDY #$0000 : LDA #$0600 : JSL SetStepFallFX : RTS
	StepSmokeFX: JSL CheckLiquid : BCC + : RTS
	+	LDX #$0C08 : LDA $0A1E : BIT #$0004 : BEQ + : LDX #$080C
		+	LDY #$0000 : LDA #$0700 : JSL SetStepFallFX : RTS
Padbyte $FF : Pad $90EEE7
org $91F0A5 : LDA $079D : AND #$0003 : ASL A : TAX : JSR (FallFXTable,X) : RTS
	FallFXTable: DW FallNoFX,FallWaterFX,FallDustFX,FallSmokeFX
	FallNoFX: STZ $0AF0 : STZ $0AF2 : RTS
	FallWaterFX: JSL CheckLiquid : BCC + : RTS 
	+	LDX #$0407 : LDY #$0004 : LDA #$0100 : JSL SetStepFallFX : RTS
	FallDustFX: JSL CheckLiquid : BCC + : RTS
	+	LDX #$0810 : LDY #$0000 : LDA #$0600 : JSL SetStepFallFX : RTS
	FallSmokeFX: JSL CheckLiquid : BCC + : RTS
	+	LDX #$0810 : LDY #$0000 : LDA #$0700 : JSL SetStepFallFX : RTS
assume mx:%00			
SetStepFallFX:	 STA $0AF0 : STA $0AF2
	LDA #$0003 : STA $0AD8 : STA $0ADA
		TXA : AND #$FF : STA $14
		TXA : XBA : AND #$FF : STA $16
		STY $18
	LDA $0AF6 : CLC : ADC $16 : STA $0AE0
				SEC : SBC $14 : STA $0AE2
	LDA $12 : SEC : SBC $18 : STA $0AE8 : STA $0AEA
	RTL
CheckLiquid: JSL $90EC3E
	LDA $195E : BMI + : CMP $12 : BPL ++
		LDA $197E : BIT #$04 : BNE ++ : BRA +++
+	LDA $1962 : BMI ++ : CMP $12 : BPL ++
	+++ SEC : RTL
	++	CLC : RTL
assume mx:off
Padbyte $FF : Pad $91F1D3